/*
 *     This file is part of the Squashtest platform.
 *     Copyright (C) Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.service.internal.dto.projectimporterxray.jooq.tables;

import org.jooq.Field;
import org.jooq.Name;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.Internal;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;
import org.squashtest.tm.service.internal.dto.projectimporterxray.jooq.dto.CustomFieldXrayDto;

/** This class is generated by jOOQ and modified. */
@SuppressWarnings({"all", "unchecked", "rawtypes"})
public class CustomFieldTable extends TableImpl<CustomFieldTableRecord> {

    private static final long serialVersionUID = 1L;

    @Override
    public Class<CustomFieldTableRecord> getRecordType() {
        return CustomFieldTableRecord.class;
    }

    public final TableField<CustomFieldTableRecord, Long> ID =
            createField(DSL.name("ID"), SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    public final TableField<CustomFieldTableRecord, Long> ITEM_ID =
            createField(
                    DSL.name("ITEM_ID"),
                    SQLDataType.BIGINT.defaultValue(DSL.field("NULL", SQLDataType.BIGINT)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> KEY =
            createField(
                    DSL.name("KEY"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> NAME =
            createField(
                    DSL.name("NAME"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> VALUE =
            createField(
                    DSL.name("VALUE"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, Integer> STEP_INDEX =
            createField(
                    DSL.name("STEP_INDEX"),
                    SQLDataType.INTEGER.defaultValue(DSL.field("NULL", SQLDataType.INTEGER)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> STEP_ACTION =
            createField(
                    DSL.name("STEP_ACTION"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> STEP_DATA =
            createField(
                    DSL.name("STEP_DATA"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> STEP_EXPECTED_RESULT =
            createField(
                    DSL.name("STEP_EXPECTED_RESULT"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> STEP_CALLED_TEST_KEY =
            createField(
                    DSL.name("STEP_CALLED_TEST_KEY"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> STEP_CALLED_TEST_PARAMETERS =
            createField(
                    DSL.name("STEP_CALLED_TEST_PARAMETERS"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, Integer> DATASET_ROW =
            createField(
                    DSL.name("DATASET_ROW"),
                    SQLDataType.INTEGER.defaultValue(DSL.field("NULL", SQLDataType.INTEGER)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> DATASET_NAME =
            createField(
                    DSL.name("DATASET_NAME"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> DATASET_VALUE =
            createField(
                    DSL.name("DATASET_VALUE"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> PIVOT_ID =
            createField(
                    DSL.name("CUF_PIVOT_ID"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> ISSUE_LINK_NAME =
            createField(
                    DSL.name("ISSUE_LINK_NAME"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> ISSUE_LINK_KEY =
            createField(
                    DSL.name("ISSUE_LINK_KEY"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    public final TableField<CustomFieldTableRecord, String> ISSUE_LINK_RELATIONSHIP =
            createField(
                    DSL.name("ISSUE_LINK_RELATIONSHIP"),
                    SQLDataType.CLOB.defaultValue(DSL.field("NULL", SQLDataType.CLOB)),
                    this,
                    "");

    private CustomFieldTable(Name alias, Table<CustomFieldTableRecord> aliased) {
        this(alias, aliased, null);
    }

    private CustomFieldTable(
            Name alias, Table<CustomFieldTableRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    public CustomFieldTable(int idTransaction) {
        this(DSL.name("CUSTOM_FIELD_XRAY_TABLE" + idTransaction), null);
    }

    @Override
    public UniqueKey<CustomFieldTableRecord> getPrimaryKey() {
        return Internal.createUniqueKey(
                this, DSL.name("KEY_CUSTOM_FIELD_XRAY_PRIMARY"), new TableField[] {this.ID}, true);
    }

    @Override
    public CustomFieldTable as(String alias) {
        return new CustomFieldTable(DSL.name(alias), this);
    }

    @Override
    public CustomFieldTable as(Name alias) {
        return new CustomFieldTable(alias, this);
    }

    @Override
    public CustomFieldTable as(Table<?> alias) {
        return new CustomFieldTable(alias.getQualifiedName(), this);
    }

    /** Rename this table */
    @Override
    public CustomFieldTable rename(String name) {
        return new CustomFieldTable(DSL.name(name), null);
    }

    /** Rename this table */
    @Override
    public CustomFieldTable rename(Name name) {
        return new CustomFieldTable(name, null);
    }

    /** Rename this table */
    @Override
    public CustomFieldTable rename(Table<?> name) {
        return new CustomFieldTable(name.getQualifiedName(), null);
    }

    public Field<?>[] getFields() {
        return new Field[] {
            this.ID,
            this.ITEM_ID,
            this.KEY,
            this.NAME,
            this.VALUE,
            this.STEP_INDEX,
            this.STEP_ACTION,
            this.STEP_DATA,
            this.STEP_EXPECTED_RESULT,
            this.STEP_CALLED_TEST_KEY,
            this.STEP_CALLED_TEST_PARAMETERS,
            this.DATASET_ROW,
            this.DATASET_NAME,
            this.DATASET_VALUE,
            this.PIVOT_ID,
            this.ISSUE_LINK_NAME,
            this.ISSUE_LINK_KEY,
            this.ISSUE_LINK_RELATIONSHIP
        };
    }

    public Object[] getValues(CustomFieldXrayDto customFieldXrayDto) {
        return new Object[] {
            customFieldXrayDto.getId(),
            customFieldXrayDto.getItemId(),
            customFieldXrayDto.getKey(),
            customFieldXrayDto.getName(),
            customFieldXrayDto.getValue(),
            customFieldXrayDto.getStepIndex(),
            customFieldXrayDto.getStepAction(),
            customFieldXrayDto.getStepData(),
            customFieldXrayDto.getStepExpectedResult(),
            customFieldXrayDto.getStepCalledTestKey(),
            customFieldXrayDto.getStepCalledTestParameters(),
            customFieldXrayDto.getDatasetRow(),
            customFieldXrayDto.getDatasetName(),
            customFieldXrayDto.getDatasetValue(),
            customFieldXrayDto.getPivotId(),
            customFieldXrayDto.getIssueLinkKey(),
            customFieldXrayDto.getIssueLinkName(),
            customFieldXrayDto.getIssueLinkRelationship()
        };
    }
}
